<?php

include_once("scoreboard.cfg");

function zphone_manager_get_cached( $q ) {

    $z=1;
    $socket = @fsockopen("127.0.0.1","5039", $errno, $errstr, 2);
    if ( !$socket ) {
        syslog(LOG_WARNING, "ZPHONE ".__FUNCTION__." error: ".$errstr." ");
        return zphone_manager_db_get( $family );
    }
    stream_set_timeout($socket, 0, 10000 );

    $actionID = substr(time(),5,5).substr($_SERVER["REMOTE_ADDR"],strlen($_SERVER["REMOTE_ADDR"])-6,6).rand();

    fputs($socket, "Action: Login\r\n");
    fputs($socket, "UserName: z_mrtg\r\n");
    fputs($socket, "Secret: z_mrtg\r\n\r\n");

    fputs($socket, "Action: QueueStatus\r\n");
    fputs($socket, "Queue: ".$q."\r\n");
    fputs($socket, "ActionID: ".$actionID."\r\n\r\n");

    $tst = true;
    $str = "";
    while ( $tst  ) {

        $line = fread($socket, 8192);
        $line2 = trim($line);

        if ( substr_count($line2,"QueueStatusComplete") ) {
           $tst = false;
        }
        $str .= $line;

        if ( $z == 20 )
            $tst = false;

        if ( $line2 == "" )
            $z++;

    }
    fputs($socket, "Action: Logoff\r\n\r\n");
    fclose($socket);

    //print($str."=================\n");
    
    return $str;


}

function split_data($str) {

    $tmp = array();
    $R   = array();
    
    foreach ( explode("\n", $str ) as $line ) {
    
	$line = trim($line);
	$tmp = explode(": ", $line);
	$R[$tmp[0]] = $tmp[1];
    }
    
    return $R;
    
}

function ast_q_status($q) {

	/*
        $socket = fsockopen("127.0.0.1","5038", $errno, $errstr, $timeout);

        fputs($socket, "Action: Login\r\n");
        fputs($socket, "UserName: z_manager\r\n");
        fputs($socket, "Secret: z_manager\r\n\r\n");


        fputs($socket, "Action: QueueStatus\r\n");
        fputs($socket, "Queue: ".$q."\r\n\r\n");


        fputs($socket, "Action: Logoff\r\n\r\n");

        while ( !feof($socket) )
            $wrets .= fread($socket, 8192);

        fclose($socket);
	*/

	$wrets = zphone_manager_get_cached( $q );

        $Q  = array();
        $_Q = array();
        $i = 0;
        foreach ( explode("\n", $wrets) as $line ) {

            $line = trim($line);
            if ( $line == "" ) {
                $i++;
            } else {
                $_Q[$i] .= $line."\n";
            }

        }
	
	foreach ( $_Q as $str ) {
	    $str = trim($str);
	    if ( substr_count($str, $q ) )
		$Q[] = $str;
	}
	
	$QD = array();
	$QD["member"] = array();
	if ( file_exists($q.".cfg") )
	    include($q.".cfg");	
	$QD["member"] = $member;
	
	//var_dump($Q);
	
	foreach ( $Q as $str ) {
	    if ( substr_count($str, "QueueParams") ){
		$QD["param"] = split_data($str);
	    } elseif ( substr_count($str, "QueueMember") ) {
	    
		if ( file_exists($q.".cfg") )
		    include($q.".cfg");
		    
		$md = split_data($str);
		$QD["member"][$md["Name"]] = $md;
	    } elseif ( substr_count($str, "QueueEntry") ) {
		$QD["waiting"][] = split_data($str);
	    }
	}
	
	//var_dump("<pre>",$QD,"</pre>");
        return $QD;

}

function ast_scoreboard( $q, $img="", $w=120, $h=100, $css_agent="black10b",$agent_per_row=9, $css_box="black12b" ) {
    $QD = ast_q_status($q);
?>
	<table width="95%" align="center" cellpadding="0" cellspacing="0" border="0" style="border:2px dashed;border-color:#3B5998;">
	    <tr bgcolor="#5F96BA" height="100">
        	<td align="center" class="black16b" width="450">
		<?php
		if ( !empty($img) )
		    print("<img src=\"".$img."\" height=\"70\">\n");
		?>
		</td>
		    
<?php
	    if ( count($QD["waiting"]) >= 5 )
		$bg = " bgcolor=\"red\" ";
	    elseif ( count($QD["waiting"]) == 4 )
		$bg =" bgcolor=\"#FE6E05\" ";
	    elseif ( count($QD["waiting"]) == 3 )
		$bg =" bgcolor=\"yellow\" ";

	    else
		$bg =" bgcolor=\"#5F96BA\" ";
?>

        	<td align="center" class="black24b" <?php print($bg); ?> >Wartezeit<br> &Oslash;: <?php print($QD["param"]["Holdtime"]);?> s
        	<td align="center" class="black24b" <?php print($bg); ?> >Wartende<br> <?php print(count($QD["waiting"]));?>

	    </tr>


	    
	    <tr>
		<td colspan="3" align="center" <?php
		if ( count($QD["member"]) == 0 )
		    print("bgcolor=\"red\" ");
		?>>
		
		    <?php
			$i=1;
			foreach ( $QD["member"] as $arr ) {
			
			    $bg = "#ECECEC";
			    if ( $arr["Status"] == 1 )
				$bg = "#7FC242";
			    elseif ( $arr["Status"] == 6 )
				$bg = "#FE6E05";
			    elseif ( $arr["Status"] == 2 )
				$bg = "#B7002E";
			
			    $css = " style=\"border:1px dotted;border-color:#B7002E;margin:5px\" ";
			    print("<table align=\"left\" border=\"0\" width=\"".$w."\" height=\"".$h."\" cellspacing=\"2\" cellpadding=\"2\" $css >\n");
			    print("\t<tr>\n\t<td align=\"center\" bgcolor=\"".$bg."\" class=\"".$css_box."\" id=\"".$q."_".$arr["Name"]."\">\n");
			
			    if  ( substr_count($arr["Name"], "Agent/") )
				print("\t\t<span class=\"".$css_agent."\">".substr(str_replace("Agent/","",$arr["Name"]),4)."</span><br>\n");
			    else	
				print("\t\t<span class=\"".$css_agent."\">".$arr["Name"]."</span><br>\n");
			    
			    if ( $arr["Status"] ) {
				print("\t\t\tAnrufe: ".$arr["CallsTaken"]."<br>\n");
				
				if ( $arr["LastCall"] > 0 )
				    $arr["LastCall"] = date("i:s",time()-$arr["LastCall"]);
				    
				print("\t\t\tlast: ".$arr["LastCall"]." s<br>\n");				
			    } else {
				print("\t\t\tAgent offline\n");
			    }			    
			    print("</td>\n</tr>\n");
			    print("</table>\n");

			if ( $i++==$agent_per_row ) {
			    print("<br clear=\"all\">\n");
			    $i=1;
			}


			}
			
		    ?>
		
		</td>
	    </tr>


	</table>
<?php
}


?>
<html>
    <head>
	<title>SCOREBOARD</title>
        <link rel="stylesheet" type="text/css" href="sc.css">
    </head>
    
    <body bgcolor="#CCE4EE"  leftmargin="0" topmargin="0" onload="window.setTimeout('location.reload()',<?php print($MAIN["refresh"]) ?>);" name="main" marginheight="0" marginwidth="0">

    <table width="100%" height="100%" align="center">
    <tr><td valign="middle" align="center">
    

    <?php
    $q_count = 0;
    foreach ( $_GET as $key => $val ) {
	if ( substr_count($key, "queue") ) {
	    if ( $MAIN["Q"][$val] ) {
		ast_scoreboard($val,$MAIN["Q"][$val]["logo"], $MAIN["PROFILE"][$_GET["profile"]]["agent_w"], $MAIN["PROFILE"][$_GET["profile"]]["agent_h"],$MAIN["PROFILE"][$_GET["profile"]]["agent_css"],$MAIN["PROFILE"][$_GET["profile"]]["agent_p_row"], $MAIN["PROFILE"][$_GET["profile"]]["box_css"]);
		print("<br>");
		$q_count++;
	    }
	}
    }

    if ( $q_count == 0 ) {
	foreach ( explode(",", $MAIN["DEFAULT"]["queues"]) as $val ) {

	    if ( $MAIN["Q"][$val] ) {
		ast_scoreboard($val,$MAIN["Q"][$val]["logo"], $MAIN["DEFAULT"]["agent_w"], $MAIN["DEFAULT"]["agent_h"],$MAIN["DEFAULT"]["agent_css"], $MAIN["DEFAULT"]["agent_p_row"],$MAIN["DEFAULT"]["box_css"] );
		print("<br>");
	    }
	    
	}
    }

    ?>
	</td>
	</tr>
    </table>
    </body>
</html>
