#!/bin/sh
#
# simple mail-to-fax utility using both faxmail and sendfax.
#
# - Lee Howard
#

#
# Mail addresses can be three ways:
#       1) user@host.org
#       2) "User Name" <user@host.org>
#       3) user@host.org (User Name)
#
# in the latter cases, quotes may or may not be used,
# there may or may not be any User Name at all, and User Name
# may come before or after user@host.org.
#
# We need to make sure we handle all these possibilities for
# both TO and FROM situations.  Return-Path is different.
#

RANDOMFAX=/tmp/mail2fax.$$
mkdir $RANDOMFAX

cat >> $RANDOMFAX/_message_

# Uncomment the following three lines for debugging.
#set -x
#exec > /tmp/mail2faxlog.$$ 2>&1
#cp $RANDOMFAX/_message_ /tmp/mail2faxmail.$$

JOBID=`grep -e "^subject:" -i $RANDOMFAX/_message_ | sed q | sed 's/^[^:]*: *//g'`
TOLINE=`grep -e "^to:" -i $RANDOMFAX/_message_ | sed q`
FROMLINE=`grep -e "^from:" -i $RANDOMFAX/_message_ | sed q`

if [ "`echo $TOLINE | grep '<.*>'`" != "" ]; then
        TONUMBER=`echo $TOLINE| sed -e 's/.*<\(.*[^@]*\)@.*>.*/\1/'`
else
        TONUMBER=`echo $TOLINE| sed -e 's/^[Tt]o://g' -e 's/[ ]*\(.*[^@]*\)@.*/\1/'`
fi

# extract the number from rfc822 string
TOLINE=`echo $TOLINE|cut -d@ -f1|cut -d\< -f2`

if [ "`echo $FROMLINE | grep '<.*>'`" != "" ]; then
        FROMPATH=`echo $FROMLINE| sed -e 's/.*<\(.*\).*>.*/\1/'`
else
        FROMPATH=`echo $FROMLINE| sed -e 's/^[Ff]rom://g' -e 's/[ ]*\([^ ]*\).*/\1/'`
fi

if [ "$JOBID" = "" ];then
    JOBID="Faxjob an $TOLINE"
fi

echo FROM: $FROMPATH TO: $TOLINE JID: $JOBID
munpack -C $RANDOMFAX $RANDOMFAX/_message_
sendfax -R -m -n -f "$FROMPATH" -i "$JOBID" -D -d $TOLINE $RANDOMFAX/*.pdf

# cat $RANDOMFAX/_message_ | faxmail -v -T $FROMPATH | sendfax -vv -n -D -f "$FROMPATH" -i "$JOBID" -d $TONUMBER

# rm -rf $RANDOMFAX

exit 0
