#!/usr/bin/php -q
<?php
ini_set("error_reporting", "E_ERROR");
ini_set("display_errors", 0);

include_once("/var/www/zphone/etc/config.inc.php");
include($CCBOX["INC"]."func_sql.inc.php");
include($CCBOX["INC"]."ccbox.inc.php");
include($CCBOX["INC"]."func_baudisch.inc.php");
include($CCBOX["INC"]."func_videomplex.inc.php");
include($CCBOX["INC"]."func_voip.inc.php");
include($CCBOX["INC"]."func_voip_system.inc.php");
include($CCBOX["INC"]."func_manager.inc.php");
include($CCBOX["INC"]."func_webtapi_mgr.inc.php");

function zphone_system_peer_watcher_daemon_custom() {
    
    if ( !function_exists("curl_init") ) {
        print("php curl module not installed.\n");
        print("please do: apt-get instsall php5-curl\n");
        exit;
    }
    
    syslog(LOG_INFO, "zphone_peer_watcher starting....\n");
    
    $SYS        = array();
    $SYS_OLD    = array();
    $TEST_PEERS = array();
    
    $SYS = zphone_system_peer_watcher_get();
    $SYS_OLD = $SYS;
    if ( $SYS["sp_status"] == 0 )
        return 0;
    
    $t    = time();
    $EXT  = voip_ext_get_from_db();
    $CAM  = zphone_vmx_cam_list();
    $SPS  = zphone_vmx_sps_list();
    $FAIL = array();

    $failure     = false;
    $action_done = false;
    
    foreach ( $SYS["ext"] as $id ) {
        $TEST_PEERS[] = $EXT[$id]["ae_ext"];
    }

    foreach ( $SYS["sps"] as $id ) {
        $TEST_PEERS[] = $SPS[$id]["vsp_name"];
    }
    
    touch("/tmp/zphone_peer_watcher", time());
    while ( file_exists("/tmp/zphone_peer_watcher") ) {
        
        if ( (time()-$t) > 180 ) {
            
            $t   = time();
            $SYS = zphone_system_peer_watcher_get();
            
            /*
             * if the timestamp differ, it means, that the setttings changed - reload....
             */
            if ( $SYS["sp_timestamp"] != $SYS_OLD["sp_timestamp"] ) {
                
                syslog(LOG_INFO, "zphone_peer_watcher reloading settings....\n");
                
                $TEST_PEERS = array();
                $EXT        = voip_ext_get_from_db();
                $CAM        = zphone_vmx_cam_list();
                $SPS        = zphone_vmx_sps_list();
                
                foreach ( $SYS["ext"] as $id ) {
                    $TEST_PEERS[] = $EXT[$id]["ae_ext"];
                }

                foreach ( $SYS["sps"] as $id ) {
                    $TEST_PEERS[] = $SPS[$id]["vsp_name"];
                }

            }
            $SYS_OLD = $SYS;
            
            
        }

        foreach ( zphone_manager_sip_status() as $stat ) {
            if ( in_array($stat["ObjectName"], $TEST_PEERS ) )
                if ( $stat["Status"] == "UNKNOWN" || substr_count($stat["Status"],"UNREACHABLE") ) {
                    //print($stat["ObjectName"]. " gest&ouml;rt!\n");
                    syslog(LOG_WARNING, "SIPPEER ".$stat["ObjectName"]." ausgefallen\n");
                    $failure = true;
                }
        }
        
        foreach ( $SYS["cam"] as $id ) {
            //print("cam: ".$id." ".$CAM[$id]["vc_url"]."\n");
            $cam_ip = array();
            preg_match('@^(?:http://)?([^/]+)@i', $CAM[$id]["vc_url"], $cam_ip);
      
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $cam_ip[0]."/index.html");
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_HEADER, 1);
            $output = curl_exec($ch);
            curl_close($ch);

            
            if ( substr_count(substr($output,0,100), "200 OK") == 0 ) {
                //print($CAM[$id]["vc_name"]. " gest&ouml;rt!\n");
                // $FAIL["cam"][$CAM[$id]["vc_name"]] = 0;
                syslog(LOG_WARNING, "IP CAM ".$CAM[$id]["vc_name"]." ausgefallen\n");
                $failure = true;
            }
        }
        
        if ( $failure && !$action_done ) {
            $action_done = true;
            syslog(LOG_WARNING, "We have a failure. Doing action ".$SYS["sp_action"]." ...\n");
            zphone_baudisch_event_action_do_custom( $SYS["sp_action"], 1 );
        }
        
        if ( !$failure && $action_done ) {
            $action_done = false;
            syslog(LOG_WARNING, "recovering from failure...");
            zphone_baudisch_event_action_custom( $SYS["sp_action"], 0 );
        }
        
        
        
        sleep($SYS["sp_intervall"]);
        $failure = false;
        
    }
    
    syslog(LOG_INFO, "zphone_peer_watcher exiting....\n");
    return 0;
    
}

function zphone_baudisch_event_action_custom( $action, $status ) {

    syslog(LOG_INFO, __FUNCTION__." action:".$action." status: ".$status." \n");
    return true; 
    
}

set_time_limit(0);
ob_implicit_flush();


$pid = pcntl_fork();

if ( $pid == -1 ) {
    die("could not fork");
} elseif ( $pid ) {
    exit();
} else {
    // we are the child!
}

if ( posix_setsid() == -1 )
    die("could not detach form terminal\n");



// zphone_system_peer_watcher_daemon();
zphone_system_peer_watcher_daemon_custom();
return true;
?>
