#!/usr/bin/php
<?php
include("../etc/config.inc.php");
header("Content-Type: image/svg+xml");
print("<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>");
?>

<svg width="100%" height="100%" viewBox="0 0 200 100" preserveAspectRatio="none" xml:space="preserve" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" onload="init(evt)">
  <g id="graph">
    <rect id="bg" x1="0" y1="0" width="100%" height="100%" fill="white"/>
    <line id="axis_x" x1="0" y1="0" x2="0" y2="100%" fill="black" stroke="black"/>
    <line id="axis_y" x1="0" y1="100%" x2="100%" y2="100%" fill="black" stroke="black"/>
    <path id="graph_out" d="M 0 100 L 0 100" fill="none" stroke="#970000" stroke-opacity="0.5"/>
    <path id="graph_in"  d="M 0 100 L 0 100" fill="none" stroke="#2828C5" stroke-opacity="0.5"/>
    <path id="grid"  d="M0 25 L 200 25 M0 50 L 200 50 M0 75 L 200 75" stroke="gray" stroke-opacity="0.5"/>
    <text id="grid_txt1" x="98%" y="25" fill="gray" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="6" text-anchor="end"> </text>
    <text id="grid_txt2" x="98%" y="50" fill="gray" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="6" text-anchor="end"> </text>
    <text id="grid_txt3" x="98%" y="75" fill="gray" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="6" text-anchor="end"> </text>
    <text id="graph_in_lbl" x="5" y="8" fill="#970000" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="7">Chans </text>
    <text id="graph_out_lbl" x="5" y="16" fill="#2828C5" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="7">Calls </text>
    <text id="graph_in_txt" x="30" y="8" fill="#970000" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="7">0</text>
    <text id="graph_out_txt" x="30" y="16" fill="#2828C5" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="7">0</text>

    <text id="ifname" x="98%" y="8" fill="#435370" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="8" text-anchor="end">Channels</text>
    
    <text id="switch_scale" x="110" y="11" fill="#435370" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="4" text-decoration="underline"></text>
    <text id="datetime" x="66" y="5" fill="black" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="4"> </text>
    <text id="graphlast" x="110" y="5" fill="black" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="4">History 120 sek</text>
    <polygon id="axis_arrow_x" fill="black" stroke="black" points="200,100 198,98 198,100"/>

    <text id="error" x="100" y="50"  visibility="hidden" fill="blue" font-family="Arial" font-size="4" text-anchor="middle">Cannot get data about interface </text>
    <text id="collect_initial" x="100" y="50"  visibility="hidden" fill="gray" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="4" text-anchor="middle">Collecting initial data, please wait...</text>
  </g>
  <script type="text/ecmascript">
    <![CDATA[

/**
 * getURL is a proprietary Adobe function, but it's simplicity has made it very
 * popular. If getURL is undefined we spin our own by wrapping XMLHttpRequest.
 */
if (typeof getURL == 'undefined') {
  getURL = function(url, callback) {
    if (!url)
      throw 'No URL for getURL';

    try {
      if (typeof callback.operationComplete == 'function')
        callback = callback.operationComplete;
    } catch (e) {}
    if (typeof callback != 'function')
      throw 'No callback function for getURL';

    var http_request = null;
    if (typeof XMLHttpRequest != 'undefined') {
      http_request = new XMLHttpRequest();
    }
    else if (typeof ActiveXObject != 'undefined') {
      try {
        http_request = new ActiveXObject('Msxml2.XMLHTTP');
      } catch (e) {
        try {
          http_request = new ActiveXObject('Microsoft.XMLHTTP');
        } catch (e) {}
      }
    }
    if (!http_request)
      throw 'Both getURL and XMLHttpRequest are undefined';

    http_request.onreadystatechange = function() {
      if (http_request.readyState == 4) {
        callback( { success : true,
                    content : http_request.responseText,
                    contentType : http_request.getResponseHeader("Content-Type") } );
      }
    }
    http_request.open('GET', url, true);
    http_request.send(null);
  }
}

var SVGDoc = null;
var last_ifin = 0;
var last_ifout = 0;
var last_ugmt = 0;
var max = 0;
var plot_in = new Array();
var plot_out = new Array();

var max_num_points = 120;  // maximum number of plot data points
var step = 200 / max_num_points ;
var unit = 'bits';
var scale_type = 'up';

function LZ(x) {
  return (x < 0 || x > 9 ? "" : "0") + x;
}

function init(evt) {
  SVGDoc = evt.target.ownerDocument;
  // SVGDoc.getElementById("switch_unit").addEventListener("mousedown", switch_unit, false);
  SVGDoc.getElementById("switch_scale").addEventListener("mousedown", switch_scale, false);

  fetch_data();
}

function switch_unit(event)
{
  SVGDoc.getElementById('switch_unit').firstChild.data = 'Switch to ' + unit + '/s';
  unit = (unit == 'bits') ? 'bytes' : 'bits';
}

function switch_scale(event)
{
  scale_type = (scale_type == 'up') ? 'follow' : 'up';
  SVGDoc.getElementById('switch_scale').firstChild.data = 'AutoScale (' + scale_type + ')';
}

function fetch_data() {
  getURL('/tools/svg_data.php?action=calls', plot_data);
}

function plot_data(obj) {
  // Show datetimelegend
  var now = new Date();
  var datetime = (now.getMonth()+1) + "/" + now.getDate() + "/" + now.getFullYear() + ' ' + 
    LZ(now.getHours()) + ":" + LZ(now.getMinutes()) + ":" + LZ(now.getSeconds());
  SVGDoc.getElementById('datetime').firstChild.data = datetime;

  if (!obj.success)
    return handle_error();  // getURL failed to get data

  var t = obj.content.split("|");
  var ugmt = parseFloat(t[0]);  // ugmt is an unixtimestamp style
  var ifin = parseInt(t[1]);    // number of bytes received by the interface
  var ifout = parseInt(t[2]);   // number of bytes sent by the interface
  var scale;

  if (!isNumber(ifin) || !isNumber(ifout))
    return handle_error();

  var diff_ugmt  = ugmt - last_ugmt;
  var diff_ifin  = ifin;
  var diff_ifout = ifout;

  if (diff_ugmt == 0)
    diff_ugmt = 1;  /* avoid division by zero */

  last_ugmt = ugmt;
  last_ifin = ifin;
  last_ifout = ifout;
  
  switch (plot_in.length) {
      case 0:
          SVGDoc.getElementById("collect_initial").setAttributeNS(null, 'visibility', 'visible');
        plot_in[0] = diff_ifin;
        plot_out[0] = diff_ifout;
        setTimeout('fetch_data()',1000);
        return;
    case 1:
        SVGDoc.getElementById("collect_initial").setAttributeNS(null, 'visibility', 'hidden');
        break;
    case max_num_points:
        // shift plot to left if the maximum number of plot points has been reached
        var i = 0;
        while (i < max_num_points) {
          plot_in[i] = plot_in[i+1];
          plot_out[i] = plot_out[++i];
        }
        plot_in.length--;
        plot_out.length--;
  }

  plot_in[plot_in.length] = diff_ifin;
  plot_out[plot_out.length]= diff_ifout;
  var index_plot = plot_in.length - 1;

  SVGDoc.getElementById('graph_in_txt').firstChild.data = ifin;
  SVGDoc.getElementById('graph_out_txt').firstChild.data = ifout;

  /* determine peak for sensible scaling */
    i = 0;
    max = 10;
    while (i < plot_in.length) {
      if (plot_in[i] > max)
        max = plot_in[i];
      if (plot_out[i] > max)
        max = plot_out[i];
      i++;
    }

  //max = 100;
  var rmax = max;  // max, rounded up


  scale = 100/max;

  /* change labels accordingly */
  SVGDoc.getElementById('grid_txt1').firstChild.data = Math.round(3*max/4);
  SVGDoc.getElementById('grid_txt2').firstChild.data = Math.round(2*max/4);
  SVGDoc.getElementById('grid_txt3').firstChild.data = Math.round(max/4);

  var path_in = "M 0 100";
  var path_out = "M 0 100";

  for (i = 1; i < plot_in.length; i++)
  {

    var x     = step * i;
    var y_in  = 100-(plot_in[i]*scale);
    var y_out = 100-(plot_out[i]*scale);

    path_in  += " L" + x + " " + y_in;
    path_out += " L" + x + " " + y_out;
    
  }

  SVGDoc.getElementById('error').setAttributeNS(null, 'visibility', 'hidden');
  SVGDoc.getElementById('graph_in').setAttributeNS(null, 'd', path_in);
  SVGDoc.getElementById('graph_out').setAttributeNS(null, 'd', path_out);

  setTimeout('fetch_data()',1000);
}

function handle_error() {
  SVGDoc.getElementById("error").setAttributeNS(null, 'visibility', 'visible');
  setTimeout('fetch_data()',1000);
}

function isNumber(a) {
  return typeof a == 'number' && isFinite(a);
}



    ]]>
  </script>
</svg>